#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>


typedef struct maillondept {
    char departement[30];
    int nbPlaces;
    char nom[30];
    struct maillondept* suiv;
}MaillonDept;


typedef MaillonDept* ListeDept;

typedef struct {
    char ville[30];
    ListeDept idDept;
}VilleIUT;

ListeDept creerListeDept(void);

ListeDept ajouterEnTeteDept(ListeDept l, char* dept, char* nom, int nbP);

ListeDept insererDept(ListeDept l, char *dept, char *nom, int nbP);

void affichageListeDept(ListeDept l);

VilleIUT lireVille(FILE *flot);

ListeDept traiterDept(ListeDept l, FILE *flot);

VilleIUT** chargementVille(char* nomFich, int tphys, int* tailleL);

ListeDept supprimerDept(ListeDept l, char *code);

int longueurListe(ListeDept l);

void SauvegarderIUT(VilleIUT** tabV, int tailleL);

void SauvegarderListe(ListeDept l, FILE* flot);

bool verifSelection(void);

void creationDept(VilleIUT **tiut, int nbEle);

int rechVille(VilleIUT **tiut, int nbEle, char code[], int *trouve);

int verifChefDepart(VilleIUT** tiut, int nbEle, char* dept, char* ville, char* nom);

int menuResponsableAffiche(void);

int gestionResponsable(VilleIUT **tiut, int nbEle, Candidat** tcandid, int tailleL);



// PARTIE 3

typedef struct
{
    char departement[30];
    int decisionDept;
    int decisionCandid;
}ChoixDept;

typedef struct maillonEtu
{
    char iutCandid[30];
    int nbChoix;
    ChoixDept **tabDept;
    struct maillonEtu *suiv;
}MaillonCandid, *ListeCandid;

typedef struct
{
    int id;
    char nom[30];
    char prenom[30];
    float note[4];
    MaillonCandid *idCandIUT;
}Candidat;


int traiterCandidIUTDept(Candidat* candid,char* dept, char* ville);

Candidat** candidDept(Candidat** tabCandidat, char* dept, char* ville, int tailleL);

void SauvegardeCandidAdmis(Candidat** tab, int nb, int admis);

void examinerCandid(Candidat **tabCandid, int nb);

int gestionResponsable(VilleIUT **tiut, int nbEle);

